 /********************************************************************************
*										*
*	Program  ::mpi_example11.c						*
*	Description :: Uppertriangle transfer of matrix using MPI_Type_indexed	*
*										*
*********************************************************************************/ 

//Include standard header files
#include <stdio.h>
#include <mpi.h>
//Include user defined header files

//Defines

//Global variables

//Pass argc and argv for main
int main (int argc, char *argv[])
 {
	//Int variables for Process number & number of processes .
	int  rank, size;

	//Intialize MPI
	MPI_Init (&argc, &argv);
	//Get number of processes
	MPI_Comm_size (MPI_COMM_WORLD, &size);
	//Get processes  number 
	MPI_Comm_rank (MPI_COMM_WORLD, &rank);

	int row_size=5,col_size=5,row=0;

	//Declare a matrix
	int array[row_size][col_size];
		
	//Define new data type
	int cnt=5,col,blocklength[col_size],disp[col_size];
	int count=col_size;
	for(row=0;row<col_size;row++)
	{
		blocklength[row]=col_size-row;
		disp[row]=row_size*row+row;
	}
		
	MPI_Datatype upper_tri;
	MPI_Type_indexed(count,blocklength,disp,MPI_INT,&upper_tri);		
	MPI_Type_commit(&upper_tri); 

	//Sender		
	if(rank==0)
	{	
		printf("Matrix @ sender\n");
		for(row=0;row<row_size;row++)
		{	for(col=0;col<col_size;col++)
				{
					array[row][col]=cnt++;
					printf("a%d\t", array[row][col]);
				}
			printf("\n");
			
		}
		//Send new datatype to 2nd rank
		MPI_Send(&array[0], 1, upper_tri,2, 0, MPI_COMM_WORLD);
	}
	//Receiver
	if(rank==2)
	{	for(row=0;row<1000;row++);
		printf("Matrix @ receiver\n");
		for(row=0;row<row_size;row++)
		{	for(col=0;col<col_size;col++)
				{
					array[row][col]=0;
					printf("b%d\t", array[row][col]);
				}
			printf("\n");
		}
		//Receiver
		MPI_Recv(&array[0][0],1,upper_tri,0,0,MPI_COMM_WORLD,MPI_STATUS_IGNORE);
		printf("After Receiving\n");
		for(row=0;row<row_size;row++)
		{	for(col=0;col<col_size;col++)
				{
					printf("u%d\t", array[row][col]);
				}
			printf("\n");
		}
		
	}
	
	//Finalize MPI
	MPI_Finalize ();
	return 0;
 }
