/********************************************************************************
*										*
*	Program  ::mpi_example12.c						*
*	Description :: Pack 2 elements and receive it as array			*
*										*
*********************************************************************************/ 

//Include standard header files
#include <stdio.h>
#include <mpi.h>
//Include user defined header files

//Defines

//Global variables

//Pass argc and argv for main
int main (int argc, char *argv[])
 {
	//Int variables for Process number & number of processes .
	int  rank, size;

	//Intialize MPI
	MPI_Init (&argc, &argv);
	//Get number of processes
	MPI_Comm_size (MPI_COMM_WORLD, &size);
	//Get processes  number 
	MPI_Comm_rank (MPI_COMM_WORLD, &rank);
	
	MPI_Status *status;

	int position,i,j,a[2];
	char buff[1000];
	//Sender
	if (rank == 0)
	{	position=0;
		i=10;
		j=11;
		//Pack i and j
		MPI_Pack(&i,1,MPI_INT,buff,1000,&position,MPI_COMM_WORLD);		
		MPI_Pack(&j,1,MPI_INT,buff,1000,&position,MPI_COMM_WORLD);
		MPI_Send(buff,position,MPI_PACKED,1,0,MPI_COMM_WORLD);
	}
	//Receiver
	if(rank==1)
	{
		//Receive Packed data in array
		MPI_Recv(a,2,MPI_INT,0,0,MPI_COMM_WORLD,MPI_STATUS_IGNORE);
		printf("a[0]=%d\ta[1]=%d\n",a[0],a[1]); 
	}		
	MPI_Finalize();
	return 0;
}
