 /********************************************************************************
*										*
*	Program  ::mpi_example13.c						*
*	Description :: Column transfer using MPI_Type_vector (3rd Column)	*
*										*
*********************************************************************************/ 

//Include standard header files
#include <stdio.h>
#include <mpi.h>
//Include user defined header files

//Defines

//Global variables

//Pass argc and argv for main
int main (int argc, char *argv[])
 {
	//Int variables for Process number & number of processes .
	int  rank, size;

	//Intialize MPI
	MPI_Init (&argc, &argv);
	//Get number of processes
	MPI_Comm_size (MPI_COMM_WORLD, &size);
	//Get processes  number 
	MPI_Comm_rank (MPI_COMM_WORLD, &rank);

	int row_size=5,col_size=5 , row=0;
	
             
	//Declare a matrix
	int array[row_size][col_size];
	//Define Vector datatype
	int cnt=5,col;
	MPI_Datatype column_mpi;
	int count=col_size, blocklength=1,stride=row_size;
	MPI_Type_vector(count,blocklength,stride,MPI_INT,&column_mpi);		
	MPI_Type_commit(&column_mpi); 

	//0 task		
	if(rank==0)
	{	printf("Matrix\n");
		for(row=0;row<row_size;row++)
		{	for(col=0;col<col_size;col++)
				{
					array[row][col]=cnt++;
					printf("a%d\t", array[row][col]);
				}
			printf("\n");
		}
		//Send 3rd column to 1 rank
		MPI_Send(&array[0][3], 1, column_mpi,1, 0, MPI_COMM_WORLD);
	}
	if(rank==1)
	{	
		int column[col_size];
		printf("Vector\n");
		MPI_Recv(&column[0],col_size,MPI_INT,0,0,MPI_COMM_WORLD,MPI_STATUS_IGNORE);
		
		for(row=0;row<col_size;row++)
			printf("Vec%d\t", column[row]);
		printf("\n");
		
	}
	
	//Finalize MPI
	MPI_Finalize ();
	return 0;
 }
