 /********************************************************************************
*										*
*	Program  ::mpi_example15.c						*
*	Description :: Demonstrating mpi threads,serialized			*
*	Thread i of rank 0 receiving i from thread i of ith ranks		*
*										*
*********************************************************************************/ 

//Include standard header files
#include <stdio.h>
#include <mpi.h>
//Include user defined header files

//Defines

//Global variables

//Pass argc and argv for main
int main (int argc, char *argv[])
 {
	//Int variables for Process number & number of processes .
	int  rank, size,req=MPI_THREAD_SERIALIZED,prov;
	printf("MPI_THREAD_SINGLE=%d\nMPI_THREAD_FUNNELED=%d\nMPI_THREAD_SERIALIZED=%d\nMPI_THREAD_MULTIPLE=%d\n",MPI_THREAD_SINGLE,MPI_THREAD_FUNNELED,MPI_THREAD_SERIALIZED,MPI_THREAD_MULTIPLE);
	//Intialize MPI
	MPI_Init_thread(&argc, &argv,req, &prov);
	//Get number of processes
	MPI_Comm_size (MPI_COMM_WORLD, &size);
	//Get processes  number 
	MPI_Comm_rank (MPI_COMM_WORLD, &rank);
	printf("%d was provided\n",prov);

	if(rank!=0)
	{
		#pragma omp parallel 
		{
			int tid=omp_get_thread_num();
			if(rank==tid)
				MPI_Send(&tid, 1, MPI_INT, 0,rank+10, MPI_COMM_WORLD);	
		}
	}
	if(rank==0)
	{
		int tid[size-1],worker=0;
		#pragma omp parallel 
		{
			int tr_id=omp_get_thread_num();
			for(worker=1;worker < size;worker++)
			{
				if(worker==tr_id)
				{	
					MPI_Recv(&tid[worker], 1,MPI_INT,worker,worker+10,MPI_COMM_WORLD,MPI_STATUS_IGNORE);	
					printf("%d is tid[%d]\n",tid[worker],worker);
				
				}
			}
		}
		
	}
	
	MPI_Finalize ();
	return 0;
 }
