/********************************************************************************	
*										*
*										*
*	Program  :: openmp_example14.c						*
*	Description :: Demonstration for 'schedule static'			*
*										*
*********************************************************************************/ 
# include <stdlib.h>
# include <stdio.h>
# include <omp.h>
int prime_static ( int n );

main ()
{
	int  n_hi,primes;
	n_hi = 17443;
	primes = prime_static ( n_hi );
	printf ( "\nNumber of primes from 1 to %d is %8d\n  \n", n_hi, primes );
}


int prime_static ( int n )
{
	int i, j, prime, total = 0;
	# pragma omp parallel shared ( n ) private ( i, j, prime )
	# pragma omp for reduction ( + : total ) schedule ( static, 100 )
	for ( i = 2; i <= n; i++ )
	{
		prime = 1;
		for ( j = 2; j < i; j++ )
		{
			if ( i % j == 0 )
			{
				prime = 0;
				break;
			}
		}
		total = total + prime;
	}
	return total;
}

