/********************************************************************************	
*										*
*										*
*	Program  :: openmp_example15.c						*
*	Description :: Illustration of OpenMP Tasking construct  		*
*										*
*********************************************************************************/


#include<stdio.h>
#include<omp.h>

void main()
{
	//Task creation and execution
	#pragma omp parallel
	{
		#pragma omp single
		{
			printf("Total No.of Threads Created= %d\n",omp_get_num_threads());
			printf("Thread %d started creating tasks\n",omp_get_thread_num());
			int tid = omp_get_thread_num();
			printf("High(%d) \n",tid);
			printf("Performance(%d)\n",tid);
			printf("Computing(%d)\n",tid);
		}

		#pragma omp single
		{
			printf("\nTotal No.of Threads Created= %d\n",omp_get_num_threads());
			printf("Thread %d started creating tasks\n",omp_get_thread_num());
			#pragma omp task
			{
				printf("High(%d) \n",omp_get_thread_num());
			}
			#pragma omp task
			{
				printf("Performance(%d)\n",omp_get_thread_num());
			}
			#pragma omp task
			{
				printf("Computing(%d)\n",omp_get_thread_num());
			}
		}//single
	}
}
