/********************************************************************************	
*										*
*										*
*	Program  :: openmp_example19.c						*
*	Description :: Illustration of OpenMP 'cancel' & 'cancellation point'	*
			constructs						*
*										*
*********************************************************************************/

/*
	CANCEL construct is used to cancel the innermost enclosing region
		parallel
		sections
		for
		taskgroup
*/
#include<stdio.h>
#include<omp.h>

void main()
{
	int i,x=5;

	omp_set_num_threads(5);
	

	//***************************cancelling parallel region********************
	printf("\n~ CANCELLING PARALLEL REGION ~\n");
	#pragma omp parallel
	{
		int c = omp_get_cancellation();
		int tid = omp_get_thread_num(); 
		printf("Tid%d - Parallel_Cancellation Cancellation Activated? = %d\n",tid,c);
		#pragma omp cancel parallel 
		#pragma omp for
		for(i=0;i<10;i++)
		{
			printf("i = %d Tid = %d\n",i,omp_get_thread_num());		
		}
	}
	
	//***********************Cancelling Sections***************************************
	printf("\n~ CANCELLING sections REGION ~\n");

	#pragma omp parallel sections
	{
		#pragma omp section
		{
			int c=omp_get_cancellation();
			int tid = omp_get_thread_num(); 
			#pragma omp cancellation point sections
			printf("Section 1: Cancellation Activated? = %d	Tid = %d\n",c,omp_get_thread_num());
		}
		#pragma omp section
		{
			int c=omp_get_cancellation();
			#pragma omp cancel sections
			printf("Section 2: Cancellation Activated? = %d	Tid = %d\n",c,omp_get_thread_num());
		}
		#pragma omp section
		{
			int c=omp_get_cancellation();
			//#pragma omp cancellation point sections
			printf("Section 3: Cancellation Activated? = %d	Tid = %d\n",c,omp_get_thread_num());
		}
	}

	//*************************Cancelling for**************************************
	
	printf("\n~ CANCELLING for REGION\n");
	#pragma omp for
	for(i=0;i<10;i++)
	{
		//printf("i= %d	Cancellation Activated? :%d\n",i,omp_get_cancellation());
		#pragma omp cancel for if(i==4)
		printf("IF i(!=4) = %d	DO SOME WORK	Tid = %d\n",i,omp_get_thread_num());
	}

	printf("\n~ CANCELLING for in PARALLEL REGION ~\n");
	#pragma omp parallel 
	{
		#pragma omp for
		for(i=0;i<10;i++)
		{
			//printf("i= %d	Cancellation Activated? :%d\n",i,omp_get_cancellation());
			#pragma omp cancel for if(i==4)
			printf("IF i(!=4) = %d	DO SOME WORK	Tid = %d\n",i,omp_get_thread_num());
		}
	}//omp parallel
	

	//************************Cancelling taskgroup****************************
	printf("\n~ CANCELLING taskgroup REGION ~\n");
	#pragma omp parallel for	
	for(i=0;i<5;i++)
	{
		#pragma omp taskgroup
		{
			#pragma  omp task
			{
				int tid=omp_get_thread_num();

				printf("i = %d   Thread-%d\n",i,omp_get_thread_num());

				#pragma omp cancel taskgroup if(i==2)
				#pragma omp task
				{
					printf("NEST Task:  i(!=2) = %d   Thread-%d\n",i,tid);
				}

				#pragma omp cancel taskgroup if(tid==2)
				printf("TASK: i(tid != 2) = %d Already started Execution \nMUST run to completion (or) Until CANCELLATION POINT is reached	Tid = %d\n\n",i,omp_get_thread_num());
				#pragma omp cancellation point taskgroup
				printf("TASK: i= %d After Cancellation point taskgroup Tid= %d\n",i,omp_get_thread_num());
			}
		}//omp taskgroup
	}

}
