/********************************************************************************	
*										*
*										*
*	Program  :: openmp_example20.c						*
*	Description :: Illustration of OpenMP 'sections', 'master' & 'single'	*
			constructs						*
*										*
*********************************************************************************/

#include<stdio.h>
#include<omp.h>
void main()
{
	omp_set_num_threads(4);
	#pragma omp parallel
	{
		#pragma omp sections
		{
			#pragma omp section
			{
				      printf("\nSection-1: Thread- %d of Total Threads-%d\n", omp_get_thread_num(),omp_get_num_threads());
			}
			#pragma omp section
			{
				      printf("Section-2: Thread- %d of Total Threads-%d\n", omp_get_thread_num(),omp_get_num_threads());
			}
		}//sections
	}//parallel
	
	#pragma omp parallel
	{
		#pragma omp master
		{
			printf("\nMASTER: Total threads = %d  No.of Processors = %d\n",omp_get_num_threads(), omp_get_num_procs());
		}
		int tid = omp_get_thread_num();
		printf("High(%d) ",tid);
		printf("Performance(%d) ",tid);
		printf("Computing(%d)\n",tid);
	
		#pragma omp single
		{
			int tid = omp_get_thread_num();
			printf("SINGLE: Thread-%d: Total No.of Threads Created= %d\n",tid,omp_get_num_threads());
			printf("High(%d) \n",tid);
			printf("Performance(%d)\n",tid);
			printf("Computing(%d)\n",tid);
		}
	}
}
